using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CustomQueryOperators {
	public static class OrderLinesLogic {
		public static decimal Weight(this OrderLine line) {
			return line.Count * line.Item.Weight;
		}

		public static decimal Weight(this IEnumerable<OrderLine> lines) {
			if (lines == null)
				throw new ArgumentNullException("lines", "lines is null.");

			decimal sum = 0;

			foreach (var line in lines)
				sum += Weight(line);

			return sum;
		}
	}
}
