﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CustomQueryOperators {
	class Program {
		static void Main(string[] args) {
			LargeSum( );
			//HeavyOrders( );
		}

		private static void LargeSum( ) {
			// Using a custom operator that returns a different data type
			int[] values = { int.MaxValue - 3, 10 };

			int total = values.Sum( );
			//long total = values.LargeSum( );

			Console.WriteLine(total);
		}

		private static void HeavyOrders( ) {
			var rubberChicken = new Item
			{
				Name = "Rubber Chicken",
				Weight = 200
			};
			var pulley = new Item
			{
				Name = "Pulley",
				Weight = 250
			};

			var order1 = new Order( );
			order1.OrderLines.Add(new OrderLine { Item = rubberChicken, Count = 10 });
			order1.OrderLines.Add(new OrderLine { Item = pulley, Count = 10 });

			var order2 = new Order( );
			order2.OrderLines.Add(new OrderLine { Item = rubberChicken, Count = 1 });
			order2.OrderLines.Add(new OrderLine { Item = pulley, Count = 1 });

			var orders = new List<Order>( );
			orders.Add(order1);
			orders.Add(order2);

			var heavyOrders =
				from order in orders
				where order.OrderLines.Sum(line => line.Count * line.Item.Weight) > 3000
				select order;

			//var heavyOrders =
			//	from order in orders
			//	where order.OrderLines.Weight() > 3000
			//	select order;

			//var heavyOrders =
			//	from order in orders
			//	where order.IsHeavyOrder( )
			//	select order;

			foreach (var order in heavyOrders) {
				Console.WriteLine("Order: ");
				foreach (var orderLine in order.OrderLines)
					Console.WriteLine("Line: " + orderLine.Count + "x " + orderLine.Item.Name);
			}
		}
	}

	//public static class OrderStandardOperators {
	//	public static IEnumerable<Order> Where(this IEnumerable<Order> source, Func<Order, bool> predicate) {
	//		return source;
	//	}
	//}

}