﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Xml.Linq;
using System.Collections.Generic;

namespace DataWebService {
	[WebService(Namespace = "http://tempuri.org/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ToolboxItem(false)]
	// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
	// [System.Web.Script.Services.ScriptService]
	public class Service : System.Web.Services.WebService {
		[WebMethod]
		public List<CountryInfo> GetData( ) {
			return List;
		}

		[WebMethod]
		public List<CountryInfo> GetFilteredData(string prefix) {
			return new List<CountryInfo>(InternalGetFilteredData(prefix));
		}

		[WebMethod]
		public List<CountryInfo> GetFilteredAndSortedData(string filterPrefix, DataSortOrder dataSortOrder) {
			List<CountryInfo> result = GetFilteredData(filterPrefix);
			if (dataSortOrder == DataSortOrder.Population) {
				result.Sort(delegate(CountryInfo x, CountryInfo y) {
					return x.Population - y.Population;
				});
			}
			return result;
		}

		private IEnumerable<CountryInfo> InternalGetFilteredData(string prefix) {
			foreach (CountryInfo entry in List)
				if (entry.Name.StartsWith(prefix, StringComparison.CurrentCultureIgnoreCase))
					yield return entry;
		}

		List<CountryInfo> list;
		public List<CountryInfo> List {
			get {
				if (list == null)
					list = new CountryInfoList( );
				return list;
			}
		}
	}
}
